#include "h/tests.h"
#include "tests.c"
#include "lprintf.c"
#include "print.c"
#include "cio.c"

main()
{
    int errtype;
    
    spcr=0x0b;

    lprintf("\nSCC register: ");
    if (errtype=init()) {
	lprintf("FEL ****\n");
	if (errtype & 1) lprintf("        Kanal A initiering fungerar ej\n");
	if (errtype & 2) lprintf("        Kanal B initiering fungerar ej\n");
    }
    else {
	lprintf("OK\n");
    }
    lprintf("\n");
    
    errtype=0;


    lprintf("SCC signaler:\n");
    if ((errtype=linetest())==0) {
	lprintf("SCC signaler: OK\n\n");
	lprintf("SCC kommunikation:\n");
	if (errtype=comtest()) {
	lprintf("%x\n",errtype);
	    lprintf("SCC kommunikation: FEL ****\n");

	    if (errtype & 1) 
          lprintf("S{ndning fr}n kanal P02 fungerar ej!\nKolla TRxC i P02!\n");

	    if (errtype & 2) 
          lprintf("Mottagna tecken felaktiga vid P01!\nKolla RTxC och RxD i P01 samt TxD i P02!\n");

	    if (errtype & 4) 
          lprintf("S{ndning fr}n kanal P01 fungerar ej!\nKolla TRxC i P01!\n");

	    if (errtype & 8) 
          lprintf("Mottagna tecken felaktiga vid P02!\nKolla RTxC och RxD i P02 samt TxD P01!\n");

	}
	else {
	    lprintf("SCC kommunikation: OK\n");
	}
	lprintf("\n");
    }
    else {
	lprintf("SCC signaler: FEL ****\n");
	if (errtype & 1) lprintf("        Kabeln ej korrekt eller signalerna fungerar ej\n");
	if (errtype & 2) lprintf("        Prov ej utf|rt\n");
	if (errtype & 4) lprintf("        Kabeln ej korrekt eller signalerna fungerar ej\n");
	if (errtype & 8) lprintf("        Signalerna P01->P02 fungerar ej\n");
	if (errtype & 16) lprintf("        Signalerna P02->P01 fungerar ej\n");
    }

}





/**********************************************************\
* 							   *
*  RDA returns the SCC port A register pointed to          *
* 							   *
\**********************************************************/
rda(no)
int no;
{
    scca=no;
    return(scca & 255);
}






/**********************************************************\
* 							   *
*  RDB returns the SCC port B register pointed to          *
* 							   *
\**********************************************************/
rdb(no)
int no;
{
    sccb=no;
    return(sccb & 255);
}




/********************************************************\
* 							 *
*  WRA writes to the specified SCC port A register     	 *
* 							 *
\********************************************************/
wra(no,data)
int no;
byte data;
{
    scca=no;
    scca=data;
}




/********************************************************\
* 							 *
*  WRB writes to the specified SCC port B register     	 *
* 							 *
\********************************************************/
wrb(no,data)
int no;
byte data;
{
    sccb=no;
    sccb=data;
}




/********************************************************\
* 							 *
*  TRANSA sends a data byte to SCC port A              	 *
* 							 *
\********************************************************/
transa(data)
byte data;
{
    int cnt=0;
    int i,dump;
    
    while (!(rda(0) & 4)) {
	cnt++;
	dump=kick;
	if (cnt>10000) return(1);
    }
    for (i=0;i<100;i++) dump=kick;
    dataa=data;
    return(0);
}


















/********************************************************\
* 							 *
*  TRANSB sends a data byte to SCC port B              	 *
* 							 *
\********************************************************/
transb(data)
byte data;
{
    int cnt=0;
    int dump,i;

    while (!(rdb(0) & 4)) {
	cnt++;
	dump=kick;
	if (cnt>10000) return(1);
    }
    for (i=0;i<100;i++) dump=kick;
    datab=data;
    return(0);
}




/*********************************************************\
* 							  *
*  RECA reads a byte from the SCC port A                  *
* 							  *
\*********************************************************/
reca()
{
    int cnt=0;
    int dump,i;
    while (!(rda(0) & 1)) {
	cnt++;
	dump=kick;
	if (cnt>10000) return(-1);
    }
    for (i=0;i<100;i++) dump=kick;
    return(dataa & 127);
}




/*****************************************\
* 					  *
*  RECB reads a byte from the SCC port B  *
* 					  *
\*****************************************/
recb()
{
    int cnt=0;
    int dump,i;
    while (!(rdb(0) & 1)) {
	cnt++;
	dump=kick;
	if (cnt>10000) return(-1);
    }
    for (i=0;i<100;i++) dump=kick;
    return(datab & 127);
}























/***************************************************************************\
* 									    *
*  INIT sets up the SCC and performs a small test to see if this succeeded  *
* 									    *
\***************************************************************************/
init()
{
    static byte initdata[] = {
        0x00,0x00,0x00,0x41,0x44,0x2a,0x00,0x00,
	0x00,0x00,0x00,0x09,0x0b,0x00,0xa0,0x00
    };
    int i;
    byte error;
    
    error=0;
    
    wra(9,0x80);
    wrb(9,0x40);
    wra(9,0xc0);
    wrb(9,0xc0);
    delay(1);
    
    for (i=0;i<16;i++) {
	wra(i,initdata[i]);
	wrb(i,initdata[i]);
    }
    
    if (rda(12)!=initdata[12]) {
        error |= 1;
    }
    
    if (rdb(12)!=initdata[12]) {
        error |= 2;
    }

    return(error);
}




/*************************************************************************\
* 									  *
* LINETEST performs a test of the SCC communications channels by sending  *
* V24 signals between them. An interconnecting cable is needed for this.  *
* 									  *
\*************************************************************************/
linetest()
{
    int cnt;
    byte error;


    wra(5,0x28);
    if (rdb(0) == 0x5D)
	lprintf("Fel p} DCD i P02\n\n");
    else if(rdb(0) == 0x75)
	lprintf("Fel p} CTS i P02\n\n");
    else if(rdb(0) == 0x7D)
	lprintf("Fel p} RTS i P01\n\n");
    if(rdb(0) & 0x28) 
	error |= 8;

    wra(5,0x2a);
    if ((rdb(0) & 0x28) == 0x08)
	{
	error |= 8;
	lprintf("Fel p} CTS i  P02\n\n");
	}

    else if((rdb(0) & 0x28) == 0x20) 
	{
	error |= 8;
	lprintf("Fel p} DCD i  P02\n\n");
	}

    else if((rdb(0) & 0x28) != 0x28) 
	{
	error |= 8;
	lprintf("Fel p} RTS i  P01\n\n");
     lprintf("Kontrollera att Du satt fast korten och kabeln p} r{tt s{tt!\n");
	}    


    wrb(5,0x28);
    if (rda(0) == 0x5D)
	lprintf("Fel p} DCD i P01\n\n");
    else if(rda(0) == 0x75)
	lprintf("Fel p} CTS i P01\n\n");
    else if(rda(0) == 0x7D)
	lprintf("Fel p} RTS i P02\n\n");
    if(rda(0) & 0x28) 
	error |= 16;

    wrb(5,0x2a);
    if ((rda(0) & 0x28) == 0x08) 
	{
	error |= 16;
	lprintf("Fel p} CTS i  P01\n\n");
	}

    else if((rda(0) & 0x28) == 0x20) 
	{
	error |= 16;
	lprintf("Fel p} DCD i  P01\n\n");
	}

    else if((rda(0) & 0x28) != 0x28) 
	{
	error |= 16;
	lprintf("Fel p} RTS i  P02\n\n");
     lprintf("Kontrollera att Du satt fast korten och kabeln p} r{tt s{tt!\n");
	}
    return(error);
}



/**************************************************************************\
* 									   *
* COMTEST performs a communications test between the two SCC channels. An  *
* interconnecting cable is needed to perform this.			   *
* 									   *
\**************************************************************************/
comtest()
{
    int i,dump;
    byte error=0;
    
    wra(11,0x09);
    wrb(11,0x09);
    wra(5,0x2a);
    wrb(5,0x2a);
    wrb(3,0x41);
    wra(3,0x41);
    wrb(4,0x4c);
    delay(1);
    while (reca() != -1) {
	dump=dataa;
	delay(1);
    }
    for (i=0;i<200;i++) {
	if (transb(65)) error |= 1;
        if ((reca() != 65) && (i>2)) error |= 2;
 	if (error & 3) break; 
        dump=kick;
    }
    delay(3);

    while (recb() != -1) {
	dump=dataa;
	delay(1);
    }
    for (i=0;i<200;i++) {
	if (transa(65)) error |= 4;
        if ((recb() != 65) && (i>2)) error |= 8;
 	if (error & 12) break; 
        dump=kick;
    }
    delay(3);

    wra(11,0x52);
    wrb(11,0x52);
    return(error);
}



